<?php
(defined('_VALID_MOS') OR defined('_JEXEC')) or die('Direct Access to this location is not allowed.');

global $_MY_CONFIG;

if( !$_MY_CONFIG )
{
	require_once( JPATH_ROOT . DS . 'administrator' . DS . 'components' . DS . 'com_myblog' . DS . 'config.myblog.php' );
	$_MY_CONFIG 	= new MYBLOG_Config();
}

/**
 *	Info: To reset the ordering for older entries and set the new ordering for a content
 *	@params: $entry (blogContent) 
 **/
function mySortOrder(&$entry)
{
	$db		=& JFactory::getDBO();
	$strSQL	= "SELECT * FROM #__content WHERE `catid`='{$entry->catid}'";
	$db->setQuery( $strSQL );

	$result	= $db->loadObjectList();

	// If there is already an ordering, dont perform anything since My Blog doesn't allow user to change the ordering.
	// User may be editing the content, we dont want to update the ordering.
	if(!$entry->ordering)
	{
		// We give ourself a new ordering id for this specific content it.
		if(count($result) == 0)
		{
			$entry->ordering	= 1;
		}
		else
		{
			$entry->ordering	= count($result) + 1;
		}
		//$entry->store();
		$strSQL	= "UPDATE #__content SET `ordering`='{$entry->ordering}' WHERE `id`='{$entry->id}'";
		$db->setQuery( $strSQL );
		$db->query();
	}
}

/**
 * Retrieves pagination object
 **/ 
function myPagination($total, $limitstart, $limit)
{
	$pagination	= new stdClass();
	
	jimport('joomla.html.pagination');
	$pageNav				= new JPagination($total, $limitstart, $limit);
	
	$pagination->limitstart	= $limitstart;
	$pagination->limit		= $limit;
	$pagination->total		= $total;
	$pagination->footer		= $pageNav->getListFooter();
	$pagination->links		= $pageNav->getPagesLinks();

	return $pagination;
}

function mySendTrackbacks($contentId, $trackbacks)
{
	global $_MY_CONFIG;

	$mainframe	=& JFactory::getApplication();

	$sections	= $_MY_CONFIG->get('managedSections');
	
	if(!class_exists('Trackback'))
	{
		require_once( MY_LIBRARY_PATH . DS . 'trackback' . DS . 'trackback_cls.php' );
	}
	
	$strSQL	= "SELECT a.*, b.permalink, c.name "
			. "FROM #__content AS a, "
			. "#__myblog_permalinks AS b, "
			. "#__users AS c "
			. "WHERE a.id=b.contentid "
			. "AND a.id='{$contentId}' "
			. "AND a.created_by=c.id "
			. "AND a.sectionid IN ($sections)";
	$db			=& JFactory::getDBO();
	$db->setQuery( $strSQL );
	$row 	= $db->loadObject();
	$Itemid	= myGetItemId();
	
	if($trackbacks && $trackbacks != '' && $row)
	{
		$trackbacks	= explode(',', $trackbacks);
		
		foreach($trackbacks as $url)
		{
			// Check if we have already sent a trackback request.
			$strSQL	= "SELECT COUNT(*) FROM `#__myblog_tb_sent` "
					. "WHERE `url`='{$url}' AND "
					. "`contentid`='{$row->id}'";
			$db->setQuery( $strSQL );
			
			// Since we never send a request before, send it.
			if( $db->loadResult() <= 0)
			{
				$trackback	= new Trackback($mainframe->getCfg('sitename'), $row->name, 'UTF-8');
				$url		= trim(strip_tags($url));
				
				
				$content			= new stdClass();
				$content->id		= $row->id;
				$permalinkUrl		= myGetPermalinkUrl($row->id);
				$content->url		= myGetExternalLink($permalinkUrl);								
				$content->title		= $trackback->cut_short($row->title);
				$content->excerpt	= $trackback->cut_short($row->introtext . $row->fulltext);
				
				if($trackback->ping($url, $content->url, $content->title, $content->excerpt))
				{
					// Add into the database that we actually sent a trackback
					$strSQL	= "INSERT INTO `#__myblog_tb_sent` SET `url`='{$url}',`contentid`='{$content->id}'";
					$db->setQuery( $strSQL );
					$db->query();
				}
			}
						
		}
	}
	else
	{
		return false;
	}
}

function myAllowedGuestView($context)
{
	global $_MY_CONFIG;
	
	$my			=& JFactory::getUser();
	$allowed	= true;

	if($context == 'intro')
	{
		if($_MY_CONFIG->get('viewIntro') == '2' && $my->id == '0')
			$allowed	= false;
	} 
	else if($context == 'entry')
	{
		if($_MY_CONFIG->get('viewEntry') == '2' && $my->id == '0')
			$allowed	= false;
	}
	return $allowed;
}

// Add a list of new and existing tags based on the array
function myAddTags($contentId, $tags)
{
	global $_MY_CONFIG;

	include_once(MY_LIBRARY_PATH.'/tags.php');
	
	$tagObj			= new MYTags();
	$db 			=& JFactory::getDBO();

	// delete old tags used by this current content id.
	$strSQL			= "DELETE FROM #__myblog_content_categories WHERE `contentid`='{$contentId}'";
	$db->setQuery( $strSQL );
	$db->query();
		
	if( is_array( $tags ) )
	{
		// Add tags
		foreach($tags as $tag)
		{
			$tagObj->add(trim($tag));
	
			// Update the blog entry with this tag's id.
			$strSQL	= "INSERT INTO #__myblog_content_categories "
					. "(`contentid`,`category`) VALUES ($contentId, $tagObj->insertId)";
			$db->setQuery( $strSQL );
			$db->query();
		}
	}
	else
	{
		$tagObj->add(trim($tags));
	
		// Update the blog entry with this tag's id.
		$strSQL	= "INSERT INTO #__myblog_content_categories "
				. "(`contentid`,`category`) VALUES ($contentId, $tagObj->insertId)";
		$db->setQuery( $strSQL );
		$db->query();
	}
}

/**
 * Retrieves the tag id for specific tag.
 *
 * @param $tagName	Tag name. 
 */  
function myGetTagId( $tagName )
{
	$db			=& JFactory::getDBO();
	$db->setQuery("SELECT `id` FROM #__myblog_categories WHERE `name`='{$tagName}'"); 
	return $db->loadResult();
}

/**
 *	Get the tag name since we have a slug now, we need to map it to the correct tag.
 **/ 
function myGetTagName($tag)
{
	$db 	=& JFactory::getDBO();	
	$strSQL	= "SELECT name FROM #__myblog_categories WHERE `name` LIKE '{$tag}' OR `slug` LIKE '{$tag}'";
	$db->setQuery( $strSQL );
	
	return $db->loadResult();
}

function myGetUsedTags($userId)
{
	$db		=& JFactory::getDBO();
	
	$strSQL	= "SELECT DISTINCT c.name, c.slug FROM #__content AS a, "
			. "#__myblog_content_categories AS b, "
			. "#__myblog_categories AS c "
			. "WHERE a.id=b.contentid "
			. "AND c.id=b.category "
			. "AND a.created_by='{$userId}'";

	$db->setQuery($strSQL);
	return $db->loadObjectList();
}

/**
 *	Get list of tags for a given content
 */ 
function myGetTags($contentid)
{
	$db =& JFactory::getDBO();
	
	$query = "SELECT b.id,b.name, b.slug FROM #__myblog_content_categories as a,#__myblog_categories as b WHERE b.id=a.category AND a.contentid='$contentid' ORDER BY b.name DESC";
	$db->setQuery( $query );
	$result = $db->loadObjectList();
	
	// Check for slug if it exists, use it as name
	for($i = 0; $i < count($result); $i++)
	{
		$tag	= $result[$i];
		
		if($tag->slug == '')
			$tag->slug	= $tag->name;
	}

	return $result;
}

function myGetSid($length = 12)
{
	$token	= md5(uniqid('a'));
	$sid	= md5(uniqid(rand(), true));
	
	$return	= '';
	for($i = 0; $i < $length; $i++){
		$return .= substr($sid, rand(1, ($length-1)), 1 );
	}
	return $return;
}

function myGetExternalLink( $url , $xhtml = false )
{
	$uri	=& JURI::getInstance();
	$base	= $uri->toString( array('scheme', 'host', 'port'));
		
	return $base . JRoute::_( $url , $xhtml );
}

function myNotifyAdmin($contentId, $author = '', $title = '', $text = '', $isNew)
{
	global $_MY_CONFIG, $MYBLOG_LANG;
	
	$mainframe	=& JFactory::getApplication();
	$status		= false;
	$db 		=& JFactory::getDBO();
	
	// Notify administrators.
	if($_MY_CONFIG->get('allowNotification'))
	{
		$emails 	= $_MY_CONFIG->get('adminEmail');
		
		$recipients	= split(',', $_MY_CONFIG->get('adminEmail'));
		
		if(!class_exists('MYMailer'))
			include_once(MY_LIBRARY_PATH . '/mail.php');
		
		if(!class_exists('AzrulJXTemplate'))
		{
			include_once( JPATH_PLUGINS . DS . 'system' . DS . 'pc_includes' . DS . 'template.php' );
		}
			

		$sid	= myGetSid();
		$date	= strftime("%Y-%m-%d %H:%M:%S", time() + ($mainframe->getCfg('offset') * 60 * 60));

		// Maintenance mode, clear existing 'sid'
		$strSQL	= "DELETE FROM #__myblog_admin WHERE `sid`='{$sid}'";
		$db->setQuery($strSQL);
		$db->query();
		
		// Re-insert new sid
		$strSQL	= "INSERT INTO #__myblog_admin SET `sid`='{$sid}', `cid`='{$contentId}', `date`='{$date}'";
		$db->setQuery($strSQL);
		$db->query();
		
		// Publish link
		$publish	= myGetExternalLink('index.php?option=com_myblog&task=admin&do=publish&sid=' . $sid , false );
		
		// Unpublish link
		$unpublish	= myGetExternalLink('index.php?option=com_myblog&task=admin&do=unpublish&sid=' . $sid , false );
		
		// Delete link
		$delete		= myGetExternalLink('index.php?option=com_myblog&task=admin&do=remove&sid=' . $sid , false );

		$template	= new AzrulJXTemplate();
		
		$text		= strip_tags($text);
		
		if($isNew)
		{
			$content	= $template->fetch(MY_TEMPLATE_PATH . "/_default/new.notify.tmpl.html");
			
			$content	= str_replace('%PUBLISH%', $publish, $content);
			$content	= str_replace('%UNPUBLISH%', $unpublish, $content);
			$content	= str_replace('%DELETE%', $delete, $content);
			$content	= str_replace('%AUTHOR%', $author, $content);
			$content	= str_replace('%TITLE%', $title, $content);
			$content	= str_replace('%ENTRY%', $text, $content);
			
			$title		= JText::_('A new blog entry has been posted');
		}
		else
		{
			// Entry is updated.
			$content	= $template->fetch(MY_TEMPLATE_PATH . "/_default/update.notify.tmpl.html");
			
			$content	= str_replace('%UNPUBLISH%', JRoute::_($unpublish), $content);
			$content	= str_replace('%DELETE%', JRoute::_($delete), $content);
			$content	= str_replace('%AUTHOR%', $author, $content);
			$content	= str_replace('%TITLE%', $title, $content);
			$content	= str_replace('%ENTRY%', $text, $content);
			
			$title		= JText::_('A blog entry has been updated');
		}
		$mail		= new MYMailer();
		
		$status		= $mail->send($mainframe->getCfg('mailfrom'), $recipients, $title, $content);
	}
	return $status;
}

function myClearCache()
{
	$cache		=& JFactory::getCache();
	
	$cache->clean();
}

function myGetUser($session)
{	
	if($session)
	{
		$vars	= explode(':' , $session);
		
		$strSQL	= "SELECT userid, username, usertype FROM #__session WHERE `userid`='" . $vars[0] . "' "
				. "AND `session_id`='" . $vars[1] . "'";
		
		$db		=& JFactory::getDBO();
		$db->setQuery( $strSQL );
		$data	= $db->loadObject();

		if($data)
		{
			$my			=& JFactory::getUser();
			$my->id			= $data->userid;
			$my->username	= $data->username;
			$my->usertype	= $data->usertype;
			
			return $my;
		}
	}
	return false;
}

/**
 * Get the status if user is allowed to post
 * Return: boolean
 **/
function myGetUserCanPost( $id = 0 )
{
	global $_MY_CONFIG;
	
	// Check posting permissions
	$posterIds  		= explode(',', $_MY_CONFIG->get('allowedPosters'));
	$postGroups 		= explode(',', $_MY_CONFIG->get('postGroup'));
	$extraPostGroups    = explode(',', $_MY_CONFIG->get('extraPostGroups'));
	$adminPostGroups    = explode(',', $_MY_CONFIG->get('adminPostGroup'));
	
	$disallowedUsers	= explode(',', $_MY_CONFIG->get('disallowedPosters'));
	
	if( $id == 0 )
	{
		$my				=& JFactory::getUser();
	}
	else
	{
		$my				=& JFactory::getUser( $id );
	}

	$userId			= $my->id;
	$userType		= $my->usertype;
	$userName		= $my->username;
		
	if(!$userId)
	{
		return false;
	}
	
	array_walk($postGroups, 'myTrim');
	array_walk($extraPostGroups, 'myTrim');
	array_walk($adminPostGroups, 'myTrim');

	# If user is not allowed to post
	if (!in_array($userType, $adminPostGroups))
	{
		if (!in_array($userType, $extraPostGroups) and !in_array($userType, $postGroups) AND !(in_array($userId, $posterIds) OR in_array(myUserGetName($userId),$posterIds)))
		{
			return false;
		}
	}

	// Check if users is specifically blocked from posting.
	if(in_array($userId, $disallowedUsers) || in_array($userName, $disallowedUsers))
		return false;

	return true;
}

/**
 * Get the status if user is allowed to publish or unpublish
 * Return: boolean
 **/
function myGetUserCanPublish()
{
	global $_MY_CONFIG;

	$publishRights  = false;
	
	$user 		= & JFactory::getUser();
	$userId		= $user->id;
	$userType	= $user->usertype;

	// Check publishing permissions
	$posterIds      	= explode(',', $_MY_CONFIG->get('allowedPublishers'));
	$publishers     	= explode(',', $_MY_CONFIG->get('publishControlGroup'));
	$extraPublishGroups = explode(',', $_MY_CONFIG->get('extraPublishGroups'));
	$adminPublishGroup	= explode(',', $_MY_CONFIG->get('adminPublishControlGroup'));

	array_walk($extraPublishGroups, 'myTrim');

	if (in_array($userType, $extraPublishGroups) or (in_array($userId, $posterIds) or in_array(myUserGetName($userId),$posterIds)) or in_array($userType, $publishers) or in_array($userType, $adminPublishGroup))
			return true;

	return false;
}

/**
 * Get the status of the azrul video mambot
 * Return: boolean
 **/
function myGetAzVideoBot()
{
	$azVideoId  = '';

	// Get the azrul video mambot's id
	$strSQL		= "SELECT `id` FROM #__mambots WHERE `element`='azvideobot' AND `folder`='content'";
	$db->setQuery($strSQL);
	$azVideoId	= $db->loadResult();
	
	// Check if azrulvideomambot file even exists
	if(file_exists( JPATH_PLUGINS . DS . 'content' . DS . 'azvideobot.php') && ( $azVideoId ))
	{
		$strSQL = "SELECT `my_published` FROM #__myblog_mambots WHERE `mambot_id`='{$azVideoId}'";
		$db->setQuery($strSQL);

		if($db->loadResult() == "1")
		{
		    return true;
		}
	}
	return false;
}

/**
 * Get the status of Jom Comment installation and integrated on the site.
 * Return: boolean
 **/
function myGetJomComment()
{
	global $_MY_CONFIG;

	jimport( 'joomla.filesystem.file' );

	$file	= JPATH_ROOT . DS . 'administrator' . DS . 'components' . DS . 'com_jomcomment' . DS . 'config.jomcomment.php';

	if($_MY_CONFIG->get('useComment') && JFile::exists( $file ) )
	    return true;

	return false;
}

/**
 *	Get list of tags for a given user
 */ 
function myGetUserTags($uid)
{
	global $_MY_CONFIG;
	$db			=& JFactory::getDBO();
	
	$sections	= $_MY_CONFIG->get('managedSections');
	$db->setQuery("SELECT distinct(b.name) from #__content as c,#__myblog_content_categories as a,#__myblog_categories as b WHERE c.id=a.contentid and b.id=a.category and c.created_by=$uid and c.state='1' and c.sectionid in ($sections) and c.publish_up < now() ORDER BY b.name DESC");
	return $db->loadObjectList();
}

/**
 *	Replace newlines with <br/> tags
 */ 
function my_strict_nl2br($text, $replac = " <br />")
{
	return preg_replace("/\r\n|\n|\r/", $replac, $text);
}

/**
 *	Retrieve number of entries for a given user
 */ 
function myCountUserEntry($uid, $exclude_drafts = "")
{
	global $_MY_CONFIG;

	$sections   = $_MY_CONFIG->get('managedSections');
	$db			=& JFactory::getDBO();
	
	$extra 		= "";
	
	$date		=& JFactory::getDate();
	
	if ($exclude_drafts == "1")
	{
		$extra = "and state='1' and publish_up < '" . $date->toMySQL() . "'";
	}
	
	$db->setQuery("SELECT COUNT(*) FROM #__content WHERE created_by='$uid' and sectionid IN ($sections) $extra");
	$result = $db->loadResult();
	
	if ($result == "")
		return 0;
	
	return $result;
}

/**
 *	Retrieve number of comments for a given user
 */ 
function myCountUserComment($uid)
{
	global $_MY_CONFIG;
	
	$sections   = $_MY_CONFIG->get('managedSections');
	$db			=& JFactory::getDBO();
	
	$strSQL = "SELECT COUNT(*) FROM #__jomcomment AS a "
			. "INNER JOIN #__content AS b "
			. "WHERE b.id=a.contentid "
			. "AND a.option='com_myblog' "
			. "AND b.created_by='{$uid}'";
	$db->setQuery($strSQL);
	
	$result = $db->loadResult();

	if ($result == "")
		return 0;
	
	return $result;
}

/**
 *	Retrieve number of hits for a given user
 */ 
function myCountUserHits($uid)
{
	global $_MY_CONFIG;

	$db			=& JFactory::getDBO();
	$sections   = $_MY_CONFIG->get('managedSections');
	
	$db->setQuery("SELECT SUM(hits) FROM #__content WHERE created_by='$uid' and sectionid in ($sections) and state='1' and publish_up < NOW()");
	$result = $db->loadResult();
	
	if ($result == "")
		return 0;
	
	return $result;
}

/**
 *	Retrieves a list of links to the unpublsihed entries for a user
 */ 
function myGetUserDraft($uid)
{
	global $MYBLOG_LANG, $Itemid, $_MY_CONFIG;
	
	$db			=& JFactory::getDBO();
	$sections	= $_MY_CONFIG->get('managedSections');

	$db->setQuery("SELECT title,created,id FROM #__content WHERE created_by='$uid' AND state=0 and sectionid in ($sections) ORDER BY created");
	$result = $db->loadObjectList();
	$drafts = "<em>";

	if ($result)
	{
		foreach ($result as $row)
		{
			$draftlink = JRoute::_("index.php?option=com_myblog&no_html=1&task=edit&id=$row->id&Itemid=$Itemid&admin=1&tmpl=component");
			
			if ($drafts != "<em>")
				$drafts .= ", ";
			$drafts .= "<a class=\"draftLink\" href=\"$draftlink\">".$row->title."</a>";
		}
	}
	else
	{
		$drafts = $MYBLOG_LANG['_MB_NO_DRAFTS'];
	}
	
	$drafts .= "</em>";
	
	return $drafts;
}

/**
 *	Retrieves number of Jom comments for an article.
 */ 
function myCountJomcomment($article_Id, $com = "com_myblog")
{
	$db	=& JFactory::getDBO();
	
	$db->setQuery("SELECT COUNT(*) FROM #__jomcomment WHERE contentid='$article_Id' AND (`option`='$com' OR `option`='com_content') AND published='1'");
	$result = $db->loadResult();
	
	return $result;
}

/**
 * Retrieves number of articles in a selected category.
 **/
function myGetCategoryCount($categoryId)
{
	$db		=& JFactory::getDBO();
	$date	=& JFactory::getDate();
	
	$strSQL = "SELECT COUNT(*) FROM #__content "
			. "WHERE `catid`='{$categoryId}' AND `state`='1' AND created <= " . $db->Quote( $date->toMySQL() );

	$db->setQuery($strSQL);
	return $db->loadResult();
}

/**
 *	Get a list of categories for a content.
 */ 
function myCategoriesURLGet($contentid, $linkCats = true, $task="")
{
	global $Itemid, $MYBLOG_LANG;
	
	
	$result		= myGetTags($contentid);
	$catCount	= count($result);
	$link		= "";
	$task		= empty($task) ? '&task=tag' : "&task=$task" ;
	
	if($result)
	{
		$count = 0;
		
		foreach ($result as $row)
		{
			if ($link != "")
				$link .= "&nbsp;,&nbsp;";
			
			if ($linkCats)
			{
				$url	= JRoute::_('index.php?option=com_myblog' . $task . '&category=' . urlencode($row->slug) . '&Itemid=' . $Itemid);				
				$link .= "<a href=\"$url\">$row->name</a>";
			}
			else
			{
				$link .= $row->name;
			}
			$count++;
		}
	}
	else
	{
		$link .= "<em>". JText::_('BLOG UNTAGGED') ."</em>&nbsp;";
	}
	
	return $link;
}

/**
 *	Retrieves the comment link for a content
 */ 
function myCommentsURLGet($contentid, $addCommentCount = true, $task="")
{
	global $Itemid, $MYBLOG_LANG;
	
	$link = "";
	
	if ($task!="")
		$task = "&task=$task";
	
	if ($addCommentCount)
	{
		$numcomment = intval(myCountJomcomment($contentid));
	}
	
	return JText::sprintf('BLOG COMMENTS' , $numcomment ); //$link;
}


/**
 *	Gets the author username/fullname   
 */ 
function myGetAuthorName($uid, $useFullName="")
{
	$db		=& JFactory::getDBO();
	
	$select = "username";
	
	if ($useFullName == "1")
		$select = "name";
	
	$db->setQuery("SELECT $select FROM #__users WHERE id='$uid'");
	$result = $db->loadResult();
	
	return $result;
}

function myGetAuthorEmail($uid)
{
	$db		=& JFactory::getDBO();
	
	$db->setQuery("SELECT `email` FROM #__users WHERE id='$uid'");
	$result = $db->loadResult();
	
	return $result;
}

/** %UserName% 
 *	Gets the author's id
 */ 
function myGetAuthorId($name, $useFullName="")
{
	$db		=& JFactory::getDBO();
	
	$name	= urldecode($name);

	// If name is empty, just return 0 since some site somehow has username's ''
	if(!$name)
		return '0';

	// If display full name instead of username, need to check both fullname nad username,
	// just in case the blogger url param contains the username.
	if ($useFullName=="1")
	{
		$db->setQuery("SELECT id FROM #__users WHERE name RLIKE '[[:<:]]$name"."[[:>:]]' or username RLIKE '[[:<:]]$name"."[[:>:]]' ");
		$result = $db->loadResult();
		return ($result ? $result : "0");
	}
	
	// get exact username match
	$name	= $db->getEscaped( $name );

	$db->setQuery("SELECT id FROM #__users WHERE username='$name'");

	$result = $db->loadResult();

	// if not found, try get similar match
	if (!$result)
	{
		$db->setQuery("SELECT id FROM #__users WHERE username RLIKE '[[:<:]]$name"."[[:>:]]'");
		$result = $db->loadResult();
	}
	
	// if still not found, check name and see if contains username.
	if (!$result)
	{
		$db->setQuery("SELECT id FROM #__users WHERE name RLIKE '[[:<:]]$name"."[[:>:]]'");
		$result = $db->loadResult();
	}
	
	return ($result ? $result : "0");
}

/**
 *	Gets the author username/fullname 
 */ 
function myUserGetName($uid, $useFullName="")
{
	$db		=& JFactory::getDBO();
	
	$uid	= intval($uid);
	$select = "username";
	
	if ($useFullName == "1")
		$select = "name";
	
	$db->setQuery("SELECT $select FROM #__users WHERE id=$uid");
	$username = $db->loadResult();

	return $username;
}

// Return the complete & valid permalink-URL for the given content 
function myGetPermalinkUrl($uid, $task="", $blogger = '')
{	
	$db			=& JFactory::getDBO();
	$Itemid 	= myGetItemId();
	
	$db->setQuery("SELECT permalink from #__myblog_permalinks WHERE contentid='$uid'");
	$link = $db->loadResult();
	
	if (!$link OR empty($link))
	{
		// The permalink might be empty. We need to delete it
		$db->setQuery("DELETE FROM #__myblog_permalinks WHERE contentid='$uid'");
		$db->query();
		
		$db->setQuery("SELECT title from #__content WHERE id='$uid'");
		$title = $db->loadResult();
		
		// remove unwatned chars from permalink
		$link = myTitleToLink(trim($title));
		$link	.= '.html';
		
		$db->setQuery("SELECT count(*) from #__myblog_permalinks WHERE permalink='$link' and contentid!='$uid'");
		$linkExists = $db->loadResult();
		
		if ($linkExists)
		{
			$link = myTitleToLink(trim($title));
			
			$plink = "$link-$uid.html";
			$db->setQuery("SELECT contentid from #__myblog_permalinks WHERE permalink='$plink' and contentid!='$uid'");
			$count = 0;
			
			while ($db->loadResult())
			{
				$count++;
				$plink = "$link-$uid-$count.html";
				$db->setQuery("SELECT contentid from #__myblog_permalinks WHERE permalink='$plink' and contentid!='$uid'");
				$db->query();
			}
			$db->setQuery("INSERT INTO #__myblog_permalinks SET permalink='$plink',contentid='$uid'");
			$db->query();
		}
		else
		{
			$db->setQuery("INSERT INTO #__myblog_permalinks SET permalink='$link',contentid='$uid' ");
			$db->query();
		}		
	}
	
	$link = urlencode($link);
	
	if ($task!="")
	{
		$task = "&task=$task";
	}

	if ($blogger!="")
	{
		$blogger = "&blogger=$blogger";
	}
		
	$url 	= "index.php?option=com_myblog&show={$link}{$task}{$blogger}&Itemid={$Itemid}";
	$sefUrl = JRoute::_( $url );
	
	return $sefUrl;
}


function myIsValidPermalink( $permalink , $contentid )
{
	$db		=& JFactory::getDBO();
	
	$db->setQuery("SELECT count(*) from #__myblog_permalinks WHERE permalink='$permalink' AND contentid !='$contentid'");
	$result	= $db->loadResult() > 0 ? false : true;
	
	return $result;
}

// Return the complete & valid permalink-URL for the given content
function myGetPermalink($uid, $task="")
{
	$db 	=& JFactory::getDBO();
	$Itemid = myGetItemId();

	$db->setQuery("SELECT permalink from #__myblog_permalinks WHERE contentid='$uid'");
	$link = $db->loadResult();

	if (!$link OR empty($link))
	{
		// The permalink might be empty. We need to delete it
		$db->setQuery("DELETE FROM #__myblog_permalinks WHERE contentid='$uid'");
		$db->query();
		
		$db->setQuery("SELECT title from #__content WHERE id='$uid'");
		$title = $db->loadResult();

		// remove unwatned chars from permalink
		$link = myTitleToLink(trim($title));
		$link	.= '.html';
		$db->setQuery("SELECT count(*) from #__myblog_permalinks WHERE permalink='$link' and contentid!='$uid'");
		$linkExists = $db->loadResult();

		if ($linkExists)
		{
			$link = myTitleToLink(trim($title));

			$plink = "$link-$uid.html";
			$db->setQuery("SELECT contentid from #__myblog_permalinks WHERE permalink='$plink' and contentid!='$uid'");
			$count = 0;

			while ($db->loadResult())
			{
				$count++;
				$plink = "$link-$uid-$count.html";
				$db->setQuery("SELECT contentid from #__myblog_permalinks WHERE permalink='$plink' and contentid!='$uid'");
			}

			//$plink = urlencode($plink);
			$db->setQuery("INSERT INTO #__myblog_permalinks SET permalink='$plink',contentid='$uid'");
			$db->query();
   			return $plink;
		}
		else
		{
			$db->setQuery("INSERT INTO #__myblog_permalinks SET permalink='$link',contentid='$uid' ");
			$db->query();
            return $link;
		}
	}
	return $link;
}

/**
 *	Displays images on image browser, resized while maintaining aspect ratio
 */ 
function displayAndResizeImages($img_array)
{
	$uploadedImages = "";
	
	if ($img_array) {
		foreach ($img_array as $img) {
			if (!empty ($img)) {
				$img['filename'] = trim($img['filename']);
				$imageMaxSize = 80;
				$imageWidth = $img['width'];
				$imageHeight = $img['height'];
				
				if ($imageHeight > $imageMaxSize or $imageWidth > $imageMaxSize) {
					if ($imageHeight > $imageWidth) {
						$imageWidth = ($imageMaxSize / $imageHeight) * $imageWidth;
						$imageHeight = $imageMaxSize;
					} else {
						$imageHeight = ($imageMaxSize / $imageWidth) * $imageHeight;
						$imageWidth = $imageMaxSize;
					}
				}
				
				$basename = basename($img['filename']);
				
				
				$imgtag = "<img src='{$img['filename']}' hspace='4' vspace='4' align='left' alt='$basename' border='0' />";
				$imgtag = addslashes($imgtag);
				$onDblCick	 ="tinyMCE.execCommand('mceFocus',false, 'mce_editor_0');";
				$onDblCick	.="tinyMCE.execCommand('mceInsertContent',false, '$imgtag');";
				
				
				$uploadedImages .= "<div title=\"$basename\" class=\"imgContainerOut\" ondblclick=\"$onDblCick\">
					<span class=\"imgContainer\" onmouseover=\"this.className='imgContainerHover';\" onmouseout=\"this.className='imgContainer';\">
						<center>
							<img src=\"" . $img['filename'] . "\" width=\"$imageWidth\" height=\"$imageHeight\" />
						</center>
					</span>
					</div>";
			}
		}
	} else {
		$uploadedImages = " ";
	}
	
	return $uploadedImages;
}

/**
 *	Retrieves AJAX page navigation links
 */ 
function writeAjaxPageNav($comp, $func, $limit, $limitstart, $total, $loadingDivName, $loadingImgURL = "")
{
	$txt = '';
	$displayed_pages = 10;
	$total_pages = $limit ? ceil($total / $limit) : 0;
	$this_page = $limit ? ceil(($limitstart +1) / $limit) : 1;
	$start_loop = (floor(($this_page -1) / $displayed_pages)) * $displayed_pages +1;
	
	if ($start_loop + $displayed_pages -1 < $total_pages) {
		$stop_loop = $start_loop + $displayed_pages -1;
	} else {
		$stop_loop = $total_pages;
	}
	
	$link = "javascript:loading('$loadingDivName','$loadingImgURL');jax.icall('$comp','" . $func . "','" . $limit . "',";
	
			
	$pnSpace = '';
	
	if (_PN_LT || _PN_RT)
		$pnSpace = "&nbsp;";
	
	if ($this_page > 1) {
		$page = ($this_page -2) * $limit;
		$txt .= '<a href="' . "$link '0');" . '" class="pagenav" ><img border=0 src="components/com_myblog/images/Backward_16x16.png" alt=""/>' . $pnSpace . _PN_START . '</a> ';
		$txt .= '<a href="' . "$link '$page');" . '" class="pagenav" ><img border=0 src="components/com_myblog/images/Play2_16x16.png" alt=""/>' . $pnSpace . _PN_PREVIOUS . '</a> ';
	} else {
	}
	
	for ($i = $start_loop; $i <= $stop_loop; $i++) {
		$page = ($i -1) * $limit;
		
		if ($i == $this_page) {
			$txt .= '<span class="pagenav">' . $i . '</span> ';
		} else {
			$txt .= '<a href="' . "$link '$page');" . '" class="pagenav"><strong>' . $i . '</strong></a> ';
		}
	}

	if ($this_page < $total_pages) {
		$page = $this_page * $limit;
		$end_page = ($total_pages -1) * $limit;
		$txt .= '<a href="' . "$link '$page');" . '" class="pagenav">' . _PN_NEXT . $pnSpace . '<img border=0 src="components/com_myblog/images/Play_16x16.png" alt=""/></a> ';
		$txt .= '<a href="' . "$link '$end_page');" . '" class="pagenav">' . _PN_END . $pnSpace . '<img border=0 src="components/com_myblog/images/Forward_16x16.png" alt=""/></a>';
	} else {
	}
	
	return $txt;
}

/**
 *	Gets the tag clouds given a query and number of cloud variations
 */ 
function myGetTagClouds($query, $clouds = 8)
{
	$db	=& JFactory::getDBO();
	
	$db->setQuery($query);
	$rows = $db->loadObjectList();

	if (!$rows)
		return "";
	
	$vals = array();
	
	foreach ($rows as $row)
	{
		$vals["{$row->frequency}"] = $row->frequency;
	}
	$maxFreq = max($vals);
	$minFreq = min($vals);
	
	$freqSize = $maxFreq - $minFreq;
	$freqSpacing	= $freqSize / $clouds;
	
	if($freqSpacing < 1)
	{
		$freqSpacing = 1;
	}
	
	foreach ($rows as $row)
	{
		$tagClass = round($row->frequency / $freqSpacing);
		$result[] = array (
			'name' => $row->name,
			'cloud' => $tagClass,
			'slug'	=> $row->slug
		);
	}
	
	usort($result, 'mySortTags');
	return $result;	
}

/**
 *	sort tags alphabetically 
 */ 
function mySortTags($a, $b)
{
	return (strtoupper($a['name']) < strtoupper($b['name'])) ? -1 : 1;
}

/**
 *	Display page navigation, non ajaxed 
 */ 
function myWritePagesLinks($link, $total, $limitstart, $limit)
{
	$total = (int) $total;
	$limitstart = (int) max($limitstart, 0);
	$limit = (int) max($limit, 0);
	$txt = '';
	$displayed_pages = 10;
	$total_pages = $limit ? ceil($total / $limit) : 0;
	$this_page = $limit ? ceil(($limitstart +1) / $limit) : 1;
	$start_loop = (floor(($this_page -1) / $displayed_pages)) * $displayed_pages +1;
	
	if ($start_loop + $displayed_pages -1 < $total_pages) {
		$stop_loop = $start_loop + $displayed_pages -1;
	} else {
		$stop_loop = $total_pages;
	}
	
	$link .= '&amp;limit=' . $limit;
	
	if (!defined('_PN_LT') || !defined('_PN_RT'))
	{
		DEFINE('_PN_LT', '&lt;');
		DEFINE('_PN_RT', '&gt;');
	}
	
	if (!defined('_PN_START'))
		define('_PN_START', 'Start');
	
	if (!defined('_PN_PREVIOUS'))
		define('_PN_PREVIOUS', 'Previous');
	
	if (!defined('_PN_END'))
		define('_PN_END', 'End');
	
	if (!defined('_PN_NEXT'))
		define('_PN_NEXT', 'Next');
	
	$pnSpace = '';
	
	if (_PN_LT || _PN_RT)
		$pnSpace = "&nbsp;";
	
	if ($this_page > 1) {
		$page = ($this_page -2) * $limit;
		$txt .= '<a href="' . sefRelToAbs("$link&amp;limitstart=0") . '" class="pagenav" title="' . _PN_START . '"><img border=0 src="components/com_myblog/images/Backward_16x16.png" alt=""/>' . $pnSpace . _PN_START . '</a> ';
		$txt .= '<a href="' . sefRelToAbs("$link&amp;limitstart=$page") . '" class="pagenav" title="' . _PN_PREVIOUS . '"><img border=0 src="components/com_myblog/images/Play2_16x16.png" alt=""/>' . $pnSpace . _PN_PREVIOUS . '</a> ';
	} else {
		$txt .= '';
		$txt .= '';
	}
	
	for ($i = $start_loop; $i <= $stop_loop; $i++) {
		$page = ($i -1) * $limit;

		if ($i == $this_page) {
			$txt .= '<span class="pagenav">' . $i . '</span> ';
		} else {
			$txt .= '<a href="' . sefRelToAbs($link . '&amp;limitstart=' . $page) . '" class="pagenav"><strong>' . $i . '</strong></a> ';
		}
	}
	
	if ($this_page < $total_pages) {
		$page = $this_page * $limit;
		$end_page = ($total_pages -1) * $limit;
		$txt .= '<a href="' . sefRelToAbs($link . '&amp;limitstart=' . $page) . ' " class="pagenav" title="' . _PN_NEXT . '">' . _PN_NEXT . $pnSpace . '<img border=0 src="components/com_myblog/images/Play_16x16.png" alt=""/></a> ';
		$txt .= '<a href="' . sefRelToAbs($link . '&amp;limitstart=' . $end_page) . ' " class="pagenav" title="' . _PN_END . '">' . _PN_END . $pnSpace . '<img border=0 src="components/com_myblog/images/Forward_16x16.png" alt=""/></a>';
	} else {
		$txt .= '';
		$txt .= '';
	}
	
	return $txt;
}

/**
 *	Gets the blog description for a user's blog
 */ 
function myGetAuthorDescription($userid)
{
	$db		=& JFactory::getDBO();
	
	$db->setQuery("SELECT description FROM #__myblog_user WHERE user_id='$userid'");
	$desc = $db->loadResult();
	
	if (!$desc)
	{
		$desc = "<p>No desc available</p>";
	}
	
	return $desc; 
}

function myGetAuthorTitle($userid)
{
	$db		=& JFactory::getDBO();

	$db->setQuery("SELECT `title` FROM #__myblog_user WHERE user_id='$userid'");
	
	$title = $db->loadResult();

	return $title;
}


/**
 *	close all open HTML tags. works as HTML cleanup function
 */ 
function myCloseTags($html)
{
	#put all opened tags into an array
	preg_match_all("#<([a-z]+)( .*)?(?!/)>#iU",$html,$result);
	$openedtags=$result[1];
	
	#put all closed tags into an array
	preg_match_all("#</([a-z]+)>#iU",$html,$result);
	$closedtags=$result[1];
	$len_opened = count($openedtags);
	// all tags are closed
	if(count($closedtags) == $len_opened){
		return $html;
	}
	$openedtags = array_reverse($openedtags);
	// close tags
	for($i=0;$i < $len_opened;$i++) {
		if (!in_array($openedtags[$i],$closedtags) && $openedtags[$i] != 'img'){
			$html .= '</'.$openedtags[$i].'>';
		} else {
			unset($closedtags[array_search($openedtags[$i],$closedtags)]);
		}
	}
	return $html;
}

// Create a suitable link from a given title
function myTitleToLink($link)
{
    global $_MY_CONFIG;

    // Replace non-ASCII characters.
    $link = strtr($link,
	 "\xe1\xc1\xe0\xc0\xe2\xc2\xe4\xc4\xe3\xc3\xe5\xc5".
	 "\xaa\xe7\xc7\xe9\xc9\xe8\xc8\xea\xca\xeb\xcb\xed".
	 "\xcd\xec\xcc\xee\xce\xef\xcf\xf1\xd1\xf3\xd3\xf2".
	 "\xd2\xf4\xd4\xf6\xd6\xf5\xd5\x8\xd8\xba\xf0\xfa\xda".
	 "\xf9\xd9\xfb\xdb\xfc\xdc\xfd\xdd\xff\xe6\xc6\xdf\xf8",
	 "aAaAaAaAaAaAacCeEeEeEeEiIiIiIiInNo".
	 "OoOoOoOoOoOoouUuUuUuUyYyaAso");
	$link = strtr($link, $_MY_CONFIG->replacements_array);
	
    // remove quotes, spaces, and other illegal characters
    $link = preg_replace(array('/\'/', '/[^a-zA-Z0-9\-.+]+/', '/(^_|_$)/'), array('', '-', ''), $link);
    
    // Replace multiple '-' with a single '-'
	$link = ereg_replace('-(-)*', '-', $link);
	
	// Remove first occurence of '-'
	$link = ereg_replace('^-','', $link);
	
	$link	= JString::str_ireplace('.' , '' , $link );
	$link	= JString::strtolower( $link );
	
    return $link;
}

// Similar to trim, but with reference
function myTrim(&$string)
{
	$string = trim($string);
}

function i8n_date($date)
{
	global $MYBLOG_LANG;

	if($MYBLOG_LANG)
	{
		foreach($MYBLOG_LANG as $key => $val)
		{
			$date = str_replace($key, $val, $date);
		}
	}
	
	return $date;
}

/**
 * Return the pdf link for specific content
 **/
function myGetPDFLink($contentId, $ItemId)
{
	$link	= JRoute::_('index.php?view=article&id=' . $contentId . '&option=com_content&format=pdf');

	$str    = '<a title="PDF" onClick="window.open(\'' . $link . '\',\'win2\',\'status=no,toolbar=no,scrollbars=yes,titlebar=no,menubar=no,resizable=yes,width=640,height=480,directories=no,location=no\'); return false;" ';
	$str    .= 'target="_blank" href="' . $link . '">';
	$str    .= '<img border="0" name="PDF" alt="PDF" src="' . rtrim( JURI::root() , '/' ) . '/images/M_images/pdf_button.png"></a>';

	return $str;
}

/**
 * Return the Print link for specific content
 **/
function myGetPrintLink($contentId, $ItemId)
{
	$link   = JRoute::_('index.php?index.php?view=article&id=' . $contentId . '&tmpl=component&print=1&task=printblog');
	$str    = '<a title="Print" onClick="window.open(\'' . $link . '\',\'win2\',\'status=no,toolbar=no,scrollbars=yes,titlebar=no,menubar=no,resizable=yes,width=640,height=480,directories=no,location=no\'); return false;" ';
	$str    .= 'target="_blank" href="' . $link . '">';
	$str    .= '<img border="0" name="Print" alt="Print" src="' . rtrim( JURI::root() , '/' ) . '/images/M_images/printButton.png"></a>';

	return $str;
}

/**
 * Return the Back link for specific content
 **/
function myGetBackLink()
{
	global $MYBLOG_LANG;
	
	$str    = '<div class="back_button"><a href="javascript:void(0);" onClick="javascript:history.go(-1);">' . JText::_( 'BACK' ) . '</a></div>';

	return $str;
}

/**
 * Returns the Itemid for the main menu item so that
 * it doesn't conflict with the "dashboard" menu's item id
 **/  
function myGetBlogItemId()
{
	static $mbItemid = -1;
	
	if($mbItemid == -1)
	{	
		global $Itemid;
		$db			=& JFactory::getDBO();
		$mbItemid	= $Itemid;
		
		$strSQL	= "SELECT `id` FROM #__menu WHERE "
				. "`link` LIKE '%option=com_myblog%' "
				. "AND `link` NOT LIKE '%option=com_myblog&task=adminhome%' "
				. "AND `published`='1' "
				. "AND `id`='{$Itemid}'";
		$db->setQuery($strSQL);

		if(!$db->loadResult())
		{
			// The current itemId is not myblog related, ignore it, and find a valid one
			// Menu type is 'component' for Joomla 1.0 and 'components' for Jooma 1.5
			$strSQL	= "SELECT `id` FROM #__menu WHERE "
					. "(type='component' OR type='components') "
					. "AND `link`='index.php?option=com_myblog' "
					. "AND `published`='1'";
			$db->setQuery($strSQL);
			$mbItemid = $db->loadResult();
		}
	}
	return $mbItemid;
}

/**
 * Return valid Itemid for my blog links
 * If 'option' are currently on myblog, then use current ItemId 
 */  
function myGetItemId()
{
	static $mbItemid = -1;
	
	if($mbItemid == -1)
	{	
		global $Itemid;
		$db			=& JFactory::getDBO();
		$mbItemid	= $Itemid;
		$db->setQuery("select id from #__menu where link LIKE '%option=com_myblog%' and published='1' AND `id`='$Itemid'");
		if(!$db->loadResult())
		{
			// The current itemId is not myblog related, ignore it, and find a valid one
			// Menu type is 'component' for Joomla 1.0 and 'components' for Jooma 1.5
			$db->setQuery("select id from #__menu where (type='component' or type='components') and link='index.php?option=com_myblog' and published='1'");
			$mbItemid = $db->loadResult();
		}
	}

	return $mbItemid;
}

// Return the adminhome itemid
function myGetAdminItemId()
{
	static $mbItemid = -1;
	
	if($mbItemid == -1)
	{
		global $Itemid;
		
		$db			=& JFactory::getDBO();
		$mbItemid	= $Itemid;
		$db->setQuery("select id from #__menu where link LIKE '%option=com_myblog%' AND published='1' AND `id`='$Itemid' ");
		if(!$db->loadResult())
		{
			// The current itemId is not myblog related, ignore it, and find a valid one
			$db->setQuery("select id from #__menu where `link` LIKE '%option=com_myblog&task=adminhome%' AND published='1' AND `menutype`='usermenu' ");
			$mbItemid = $db->loadResult();
		}
		
		// If no link from the preferred 'usermenu' Itemid, just use whatever myblog task=adminhome itemid we can find
		if(!$mbItemid)
		{
			$db->setQuery("select id from #__menu where `link` LIKE '%option=com_myblog&task=adminhome%' AND published='1'");
			$mbItemid = $db->loadResult();
		}
		
		// If still cannot found, just search for a normal com_myblog link
		if(!$mbItemid)
		{
			$db->setQuery("select id from #__menu where `link` LIKE '%option=com_myblog%' AND published='1'");
			$mbItemid = $db->loadResult();
		}
	}
	
	return $mbItemid;
}

/** Admin Stuffs **/

// Return array of links for the dashboard tabs
function myGetDashboardLinks()
{
	global $_MY_CONFIG;

	$myitemid = myGetAdminItemId();

	$links   = array(
			JRoute::_('index.php?option=com_myblog&task=adminhome&Itemid='.$myitemid),
			JRoute::_('index.php?option=com_myblog&task=bloggerpref&Itemid='.$myitemid),
			JRoute::_('index.php?option=com_myblog&task=bloggerstats&Itemid='.$myitemid)
	);	


 	// Check if integration with Jom comment is set.
	if($_MY_CONFIG->get('useComment'))
	{
		$links[]	= JRoute::_('index.php?option=com_myblog&task=showcomments&Itemid='.$myitemid);		
	}
	return $links;
}

function myGetDashboardLinksTitle()
{
	global $_MY_CONFIG;

	include(MY_COM_PATH.'/language/'.$_MY_CONFIG->language);
	
	$captions   = array(
	                    $MYBLOG_LANG['TPL_MNU_MYBLOGS'],
	                    $MYBLOG_LANG['TPL_MNU_PREF'],
	                    $MYBLOG_LANG['TPL_MNU_STATS']
						);

 	// Check if integration with Jom comment is set.
	if($_MY_CONFIG->get('useComment')){
		$captions[] = $MYBLOG_LANG['TPL_MNU_COMMENTS'];
	}
	return $captions;
}

function myUnhtmlspecialchars( $string ){
	$string = str_replace ( '&amp;', '&', $string );
	$string = str_replace ( '&#039;', '\'', $string );
	$string = str_replace ( '&quot;', '"', $string );
	$string = str_replace ( '&lt;', '<', $string );
	$string = str_replace ( '&gt;', '>', $string );
	$string = str_replace ( '&uuml;', 'ü', $string );
	$string = str_replace ( '&Uuml;', 'Ü', $string );
	$string = str_replace ( '&auml;', 'ä', $string );
	$string = str_replace ( '&Auml;', 'Ä', $string );
	$string = str_replace ( '&ouml;', 'ö', $string );
	$string = str_replace ( '&Ouml;', 'Ö', $string );    
	return $string;
}

// Return list of all category for  the target section
function myGetCategoryList($sectionid)
{
	$categories = array();
	$db			=& JFactory::getDBO();
	$db->setQuery("SELECT * FROM #__categories WHERE `section`='$sectionid' AND `published`='1' ORDER BY title");
	$categories = $db->loadObjectList();
	 
	return $categories;
}

function myGetCategoryId($categoryName)
{
	$db			=& JFactory::getDBO();
	$db->setQuery("SELECT `id` FROM #__categories WHERE `name`='{$categoryName}'"); 
	return $db->loadResult();
}

// Custom callback function for tag sorting
// @param $a/$b is a myblog_category object
function myTagCmp($a, $b) 
{
	return strcmp($a->name, $b->name);
}

// Return the number of times the tag is used
function myCountTagUsed($tagid)
{
	$db			=& JFactory::getDBO();
	$query		= "SELECT COUNT(*) FROM #__myblog_content_categories WHERE `category`='$tagid'";
	$db->setQuery($query);
	return $db->loadResult();
}

function myGetTrackbacks($contentId)
{
	$db			=& JFactory::getDBO();
	
	$strSQL	= "SELECT `url` FROM #__myblog_tb_sent WHERE `contentid`='{$contentId}'";
	$db->setQuery($strSQL);
	
	$trackbacks	= $db->loadObjectList();
	
	$retVal		= '';
	
	foreach($trackbacks as $trackback)
	{
		$retVal	.= $trackback->url . ',';
	}
	return $retVal;
}

// Return the html code for categories list, if content id is specified, 
// Set the checkbox as slected
function myGetTagsSelectHtml($contentid = 0)
{
	$db			=& JFactory::getDBO();
	$query		= "SELECT * FROM #__myblog_categories";
	$db->setQuery($query);
	
	$result			= $db->loadObjectList();
	$currentTags	= array();
	
	if($contentid)
	{
		$ctags = myGetTags($contentid);
		if(!empty($ctags))
		{
			foreach($ctags as $ct)
				$currentTags[] = $ct->id;
		}
	}
	
	// Sort the tag alphabetically
	usort($result, 'myTagCmp');
	
	$html = '<table width="100%" border="0" align="center" cellpadding="0" cellspacing="0" ><tbody id="tagListings">';
	foreach($result as $row)
	{
		$row->useCount = myCountTagUsed($row->id);
		
		$checked = in_array($row->id, $currentTags) ? 'checked="checked"' : '';
		$html .= '<tr>
                <td valign="middle"><input type="checkbox" value="'. $row->name.'"  '.$checked.' /></td>
                <td width="100%" valign="middle"><label class="catitem" style="vertical-align:middle" title="'.$row->useCount.' blog entries">'. $row->name.'</label></td>
            </tr>';
    }
    $html .= '</tbody></table>';
	return $html;
}

// Return the html code for categories list, if content id is specified,
// Set the checkbox as slected
function myGetCategoryHtml($contentid = 0)
{
	global $_MY_CONFIG;
	
	$db			=& JFactory::getDBO();
	$sections   = $_MY_CONFIG->get('postSection');

	// Get current category if the content has been set a category
	$strSQL     = "SELECT `catid` FROM #__content WHERE `id`='{$contentid}'";
	$db->setQuery($strSQL);
	$selCat     = $db->loadResult();

	// Load the list of categories on the site and dont show unpublished categories
	$strSQL = 'SELECT * FROM #__categories WHERE `section` IN (' . $sections . ') AND `published`=\'1\'';
	$db->setQuery($strSQL);

	$categories = $db->loadObjectList();

	$html = '<select id="catid" name="catid" size="1" class="text">';
	
	foreach($categories as $row)
	{
		$rowName	= $row->title;

	    if($selCat && $selCat == $row->id)
		{
	        $html   .= '<option value="' . $row->id . '" selected="selected">' . $rowName . '</option>';
		}
		else
		{
		    $html   .= '<option value="' . $row->id . '">' . $rowName .'</option>';
		}
    }
    $html   .= '</select>';
    
	return $html;
}


function myGetJoomlaCategoryName($id)
{
	global $_MY_CONFIG;
	
	$db		=& JFactory::getDBO();
	
	$query	= "SELECT `title` FROM #__categories WHERE `id`='$id' ";
	$db->setQuery( $query );
	return $db->loadResult();
}

function getPoweredByLink()
{
	$powered_by_link = '<div align="center" style="text-align:center; font-size:90%"></div>';
	return ''; //; 
}


function myAddPathway($title, $link='')
{
	$mainframe	=& JFactory::getApplication();
	$pathway	=& $mainframe->getPathway();
	
	$pathway->addItem( $title , $link );
}

function myAddPageTitle($title)
{
	$document =& JFactory::getDocument();
	$document->setTitle($title);
}

function myAddEditorHeader()
{
	static $added	= false;
	
	if( !$added )
	{
	    $document =& JFactory::getDocument();
	    
		/**
		 * Add additional JS and CSS files
		 */
		$document->addScript( JURI::root() . 'components/com_myblog/js/myblog.js' );
		$document->addStylesheet( JURI::root() . 'components/com_myblog/css/azwindow.css' );
		$document->addStylesheet( JURI::root() . 'components/com_myblog/css/style.css' );
		$document->addStylesheet( JURI::root() . 'components/com_myblog/css/ui.css' );
	
		// add script block
		$script  = "\r\n";
	    $script .= '<!--[if lte IE 6]>'."\r\n";
		$script .= '<link href="' . JURI::root() . 'components/com_myblog/css/style.IE6.css" rel="stylesheet" type="text/css" />'."\r\n";
		$script .= '<link href="' . JURI::root() . 'components/com_myblog/css/azwindow.IE6.php" rel="stylesheet" type="text/css" />'."\r\n";
		$script .= '<style type="text/css">
	#az_tl, #az_tm, #az_tr, #az_ml, #az_mr, #az_bl, #az_bm, #az_br {
		background-image: none;
		filter:progid:DXImageTransform.Microsoft.Alpha(opacity=0);
	}
	#az_tl {
		filter: progid:DXImageTransform.Microsoft.AlphaImageLoader(enabled=true, sizingMethod=\'scale\', src=\''.JURI::root().'components/com_myblog/images/trans/tl.png\');
	}
	#az_tm {
		filter: progid:DXImageTransform.Microsoft.AlphaImageLoader(enabled=true, sizingMethod=\'scale\', src=\''.JURI::root().'components/com_myblog/images/trans/tm.png\');
	}
	#az_tr {
		filter: progid:DXImageTransform.Microsoft.AlphaImageLoader(enabled=true, sizingMethod=\'scale\', src=\''.JURI::root().'components/com_myblog/images/trans/tr.png\');
	}
	#az_ml {
		filter: progid:DXImageTransform.Microsoft.AlphaImageLoader(enabled=true, sizingMethod=\'scale\', src=\''.JURI::root().'components/com_myblog/images/trans/lm.png\');
	}
	#az_mr {
		filter: progid:DXImageTransform.Microsoft.AlphaImageLoader(enabled=true, sizingMethod=\'scale\', src=\''.JURI::root().'components/com_myblog/images/trans/rm.png\');
	}
	#az_bl {
		filter: progid:DXImageTransform.Microsoft.AlphaImageLoader(enabled=true, sizingMethod=\'scale\', src=\''.JURI::root().'components/com_myblog/images/trans/bl.png\');
	}
	#az_bm {
		filter: progid:DXImageTransform.Microsoft.AlphaImageLoader(enabled=true, sizingMethod=\'scale\', src=\''.JURI::root().'components/com_myblog/images/trans/bm.png\');
	}
	#az_br {
		filter: progid:DXImageTransform.Microsoft.AlphaImageLoader(enabled=true, sizingMethod=\'scale\', src=\''.JURI::root().'components/com_myblog/images/trans/br.png\');
	}'."\r\n";
	    $script .= '</style>'."\r\n";
		$script .= '<![endif]-->'."\r\n";
		$script .= '<!--[if IE 7]>'."\r\n";
		$script .= '<link href="' . JURI::root() . 'components/com_myblog/css/style.IE7.css" rel="stylesheet" type="text/css" />'."\r\n";
		$script .= '<![endif]-->'."\r\n";
		$document->addCustomTag( $script );
		
		$added	= true;
	}
}